using System;
using System.Linq;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using SmartX;
using ITC81DB_2.Forms;
using ITC81DB_2_ImageDll;

namespace ITC81DB_2.Controls
{
    public partial class ControlCenterSystemIOTest : UserControl
    {
        #region Field
        private FormMenu m_ParentForm;

        private Color ColorIOStatusOn;
        private Color ColorIOStatusOff;

        private Collection<Label> CollectionInputLabel;
        private Collection<SmartLabel> CollectionInputLabelName;
        private Collection<SmartButton> CollectionOutputButton;
        #endregion

        #region Constructor
        public ControlCenterSystemIOTest(FormMenu parent)
        {
            InitializeComponent();

            this.ParentForm = parent;

            this.InitializeDesign();
            this.DefaultSetting();
        }
        #endregion

        #region Property
        public FormMenu ParentForm
        {
            get { return this.m_ParentForm; }
            private set { this.m_ParentForm = value; }
        }
        #endregion

        #region Method
        public void InitializeDesign()
        {
            Class1 images = new Class1();

            if (this.ParentForm.ParentForm.SystemConfig.Language == Define.E_LanguageID.English)
            {
                this.groupBoxInput.Text = "Input";
                this.groupBoxOutput.Text = "Output";
            }
            else if (this.ParentForm.ParentForm.SystemConfig.Language == Define.E_LanguageID.Chinese)
            {
                this.groupBoxInput.Text = "输入";
                this.groupBoxOutput.Text = "输出";
            }
            else if (this.ParentForm.ParentForm.SystemConfig.Language == Define.E_LanguageID.Czech)
            {
            }
            else if (this.ParentForm.ParentForm.SystemConfig.Language == Define.E_LanguageID.Spanish)
            {
                this.groupBoxInput.Text = "Aporte";
                this.groupBoxOutput.Text = "Producción";
            }
            else
            {
                this.groupBoxInput.Text = "Input";
                this.groupBoxOutput.Text = "Output";
            }
        }
        private void DefaultSetting()
        {
            this.ColorIOStatusOn = Color.Lime;
            this.ColorIOStatusOff = Color.Gray;

            this.CollectionInputLabel = new Collection<Label>();
            this.CollectionInputLabel.Clear();
            this.CollectionInputLabel.Add(this.labelInput1);
            this.CollectionInputLabel.Add(this.labelInput2);
            this.CollectionInputLabel.Add(this.labelInput3);
            this.CollectionInputLabel.Add(this.labelInput4);
            this.CollectionInputLabel.Add(this.labelInput5);
            this.CollectionInputLabel.Add(this.labelInput6);
            this.CollectionInputLabel.Add(this.labelInput7);
            this.CollectionInputLabel.Add(this.labelInput8);
            this.CollectionInputLabel.Add(this.labelInput9);
            this.CollectionInputLabel.Add(this.labelInput10);
            this.CollectionInputLabel.Add(this.labelInput11);
            this.CollectionInputLabel.Add(this.labelInput12);
            this.CollectionInputLabel.Add(this.labelInput13);
            this.CollectionInputLabel.Add(this.labelInput14);
            this.CollectionInputLabel.Add(this.labelInput15);
            this.CollectionInputLabel.Add(this.labelInput16);

            this.CollectionInputLabelName = new Collection<SmartLabel>();
            this.CollectionInputLabelName.Clear();
            this.CollectionInputLabelName.Add(this.labelInputName1);
            this.CollectionInputLabelName.Add(this.labelInputName2);
            this.CollectionInputLabelName.Add(this.labelInputName3);
            this.CollectionInputLabelName.Add(this.labelInputName4);
            this.CollectionInputLabelName.Add(this.labelInputName5);
            this.CollectionInputLabelName.Add(this.labelInputName6);
            this.CollectionInputLabelName.Add(this.labelInputName7);
            this.CollectionInputLabelName.Add(this.labelInputName8);
            this.CollectionInputLabelName.Add(this.labelInputName9);
            this.CollectionInputLabelName.Add(this.labelInputName10);
            this.CollectionInputLabelName.Add(this.labelInputName11);
            this.CollectionInputLabelName.Add(this.labelInputName12);
            this.CollectionInputLabelName.Add(this.labelInputName13);
            this.CollectionInputLabelName.Add(this.labelInputName14);
            this.CollectionInputLabelName.Add(this.labelInputName15);
            this.CollectionInputLabelName.Add(this.labelInputName16);

            this.CollectionOutputButton = new Collection<SmartButton>();
            this.CollectionOutputButton.Clear();
            this.CollectionOutputButton.Add(this.buttonOutput1);
            this.CollectionOutputButton.Add(this.buttonOutput2);
            this.CollectionOutputButton.Add(this.buttonOutput3);
            this.CollectionOutputButton.Add(this.buttonOutput4);
            this.CollectionOutputButton.Add(this.buttonOutput5);
            this.CollectionOutputButton.Add(this.buttonOutput6);
            this.CollectionOutputButton.Add(this.buttonOutput7);
            this.CollectionOutputButton.Add(this.buttonOutput8);
            this.CollectionOutputButton.Add(this.buttonOutput9);
            this.CollectionOutputButton.Add(this.buttonOutput10);
            this.CollectionOutputButton.Add(this.buttonOutput11);
            this.CollectionOutputButton.Add(this.buttonOutput12);
            this.CollectionOutputButton.Add(this.buttonOutput13);
            this.CollectionOutputButton.Add(this.buttonOutput14);
            this.CollectionOutputButton.Add(this.buttonOutput15);
            this.CollectionOutputButton.Add(this.buttonOutput16);

            for (int i = 0; i < this.CollectionInputLabelName.Count; i++)
            {
                this.CollectionInputLabelName[i].Text = string.Format("IN{0}", i + 1);
                this.CollectionOutputButton[i].Text = string.Format("OUT{0}", i + 1);
            }

            this.buttonOutput1.Text = "Buzzer";
            this.buttonOutput2.Text = "GRN Lamp";
            this.buttonOutput3.Text = "RED Lamp";
            this.buttonOutput4.Text = "YEL Lamp";
            this.buttonOutput5.Text = "OPT";
            this.buttonOutput6.Text = "SORT A";
            this.buttonOutput7.Text = "SORT B";
            this.buttonOutput8.Text = "Motor";
            this.buttonOutput9.Text = "DRY 1";
            this.buttonOutput10.Text = "DRT 2";
            this.buttonOutput11.Text = "DRY 3";
            this.buttonOutput12.Text = "DRY 4";
            this.buttonOutput13.Text = "DRY 5";
            this.buttonOutput14.Text = "DRY 6";
            this.buttonOutput15.Text = "DRY 7";
            this.buttonOutput16.Text = "DRY 8";

            this.labelInputName1.Text = "METAL";
            this.labelInputName2.Text = "ALARM.C";
            this.labelInputName3.Text = "OPT 1";
            this.labelInputName4.Text = "INTERLOCK";
            this.labelInputName5.Text = "START";
            this.labelInputName6.Text = "STOP";
            this.labelInputName7.Text = "PhotoB";
            this.labelInputName8.Text = "PhotoA";
            this.labelInputName9.Text = "None";
            this.labelInputName10.Text = "None";
            this.labelInputName11.Text = "None";
            this.labelInputName12.Text = "None";
            this.labelInputName13.Text = "None";
            this.labelInputName14.Text = "None";
            this.labelInputName15.Text = "None";
            this.labelInputName16.Text = "None";
        }

        private void SetlabelOnOff(Label control, bool isOn)
        {
            if (isOn == true)
            {
                if (control.BackColor != this.ColorIOStatusOn)
                    control.BackColor = this.ColorIOStatusOn;
            }
            else
            {
                if (control.BackColor != this.ColorIOStatusOff)
                    control.BackColor = this.ColorIOStatusOff;
            }
        }

        public void UpdateInputRead(Collection<string> values)
        {
            if (values.Count == 0 || values == null)
                return;

            for (int i = 0; i < values.Count; i++)
                this.SetlabelOnOff(this.CollectionInputLabel[i], values[i] == "1" ? true : false);
        }

        public void DisplayRefresh(SystemStatus status)
        {
            this.ParentForm.ParentForm.CurrentSystemStatus.CurrentDisplay = Define.E_DisplayStore.SystemIOTest;
            this.ParentForm.ParentForm.SetDisplayMode(Define.E_DisplayMode.IOTest);
            this.ParentForm.DisplayTitleRoot(this.ParentForm.ParentForm.CurrentSystemStatus);

            foreach (SmartButton button in this.CollectionOutputButton)
                button.ButtonUp();
        }
        #endregion
      
        #region Event Handler
        private void buttonInputRead_Click(object sender, EventArgs e)
        {
            if (this.buttonInputRead.ButtonStatus == SmartButton.BUTSTATUS.DOWN)
                this.timer.Enabled = true;
            else
                this.timer.Enabled = false;
        }

        private void buttonOutput_Click(object sender, EventArgs e)
        {
            SmartButton button = sender as SmartButton;

            if (button == null)
                return;

            if (button.ButtonStatus == SmartButton.BUTSTATUS.DOWN)
            {
                this.ParentForm.ParentForm.TransferDataStream(CommunicationCommand.IOTest, CommunicationID.MainBoard, Helper.StringZeroFillDigits4(button.Tag.ToString()),
                    Helper.StringZeroFillDigits4("1"));
            }
            else
            {
                this.ParentForm.ParentForm.TransferDataStream(CommunicationCommand.IOTest, CommunicationID.MainBoard, Helper.StringZeroFillDigits4(button.Tag.ToString()),
                    Helper.StringZeroFillDigits4("0"));
            }
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            this.ParentForm.ParentForm.TransferDataStream(CommunicationCommand.Read, CommunicationID.MainBoard, CommunicationAddress._7500_InputAll, "");
        }
        #endregion
    }
}
